/*====================MIDISEND Begin=================================*/
void midiSend(int cmd, int level, int value){ //Send to Dream only
  Dream.write(cmd);
  Dream.write(level);
  Dream.write(value);
}
/*====================MIDISEND END==================================*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*=====================ProgramChange Begin===========================*/
void ProgramChange(char PC_data, char pc_num){ //Send to Dream only
 Dream.write(PC_data);
 Dream.write(pc_num);
}
/*=====================ProgramChange END============================*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*=====================Sustain Begin================================*/
void SustainSet(char &MIDI){
  if ((MIDI == 29) || (MIDI == 50) || (MIDI == 57) || (MIDI == 63) || (MIDI == 76) || (MIDI == 30)){
    midiSend(0xB0, 0x40, 0); //Sustain OFF
  }
  else{
    midiSend(0xB0, 0x40, 127); //Sustain ON
  }
}
/*=====================Sustain END==================================*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*=====================noteOn Begin=================================*/
void noteOn(int cmd, int pitch, int velocity){
  Serial1.write(Ch1_OFF);
  Serial1.write(Ch1_OFF);
  Serial1.write(cmd); 
  Serial1.write(pitch);
  Serial1.write(velocity);
  Dream.write(cmd);
  Dream.write(pitch);
  Dream.write(velocity);
}
/*=====================noteOn END===================================*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*=====================MelodyOn Begin===============================*/
void MelodyOn(int T, int Velocity, int &count,boolean &cut_note,unsigned long &Time, int &T_old){
  Time = millis();
  count ++;
  noteOn(Ch1_ON, T, Velocity);
  cut_note = LOW;
  T_old = T;
}
/*=====================MelodyOn END=================================*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*=====================MelodyOff Begin==============================*/
void MelodyOff(int T, int Velocity, int &count, boolean &cut_note,int &T_old){
  count = 0;
  cut_note = HIGH;
 // noteOn(0x80, T, Velocity);
  noteOn(Ch1_OFF, T_old, Velocity);
}
/*=====================MelodyOff END================================*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*=====================Mode2Play Begin==============================*/
void Mode2Play(int T, int Velocity,unsigned long &Time){
  if (millis() - Time > Mode2Interval){
    midiSend(Ch1_ON,T,Velocity);
    Time = millis();
  }
  midiSend(Ch1_OFF,T,Velocity);
}
/*=====================Mode2Play END===============================*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*=====================Note Begin===================================*/
void Note(String Message, int &note){
   if(Message.equals("SS")){ note = 37;}
   else if(Message.equals("X")){ note = 0; }
   else if(Message.equals("K")){ note = 36; }
   else if(Message.equals("O")){ note = 46; }
   else if(Message.equals("N")){ note = 40;}
   else if(Message.equals("C")){ note = 42; }
   else if(Message.equals("R")){ note = 59;}

   else if(Message.equals("1")){  note = Note_Datum;} // 80 = 1500   120=1000
   else if(Message.equals("2")){  note = Note_Datum/2;} //500
   else if(Message.equals("4")){  note = Note_Datum/4;} //250
   else if(Message.equals("8")){ note = Note_Datum/8;} //125
   else if(Message.equals("3")){ note = Note_Datum/3;} //333
}
/*=====================Note END====================================*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*=====================SetBDVelocity Begin===========================*/
void SetBDVelocity(int &Analog, int &Velocity){
  if ((Analog > Analog_0) && (Analog <= Analog_1)){ Velocity = 45; }
  if ((Analog > Analog_1 ) && (Analog <= Analog_2)){ Velocity = 60; }
  if ((Analog > Analog_2 ) && (Analog <= Analog_3)){ Velocity = 75; }
  if ((Analog > Analog_3 ) && (Analog <= Analog_4)){ Velocity = 100; }
  if (Analog > Analog_4){ Velocity = 127;}
}
/*=====================SetBDVelocity END============================*/
//////////////////////////////////////////////////////////////////////////////
/*=====================memoryFree Begin=============================*/
extern int __bss_end;
extern void *__brkval;
int memoryFree(){
  int freeValue;
  if ((int)__brkval == 0)
    freeValue = ((int)&freeValue) - ((int)&__bss_end);
  else
    freeValue = ((int)&freeValue) - ((int)__brkval);
  return freeValue;
}
/*=====================memoryFree END===============================*/
/////////////////////////////////////////////////////////////////////////////////
/*=====================Chord Set BEGIN===============================*/
void chordSet(int root,int &Fst,int &Sec, int &Thr, int &For){
  if (root < 120){ //Major
    if (root >64){ Fst = root - (down *2);}
    else{ Fst = root - down;}
    //Fst = root;   //down來降調
    Sec = Fst + 7;
    Thr = Fst + 12;
    For = Fst + 16;
  }
  else if((root >= 120) && (root < 180)){ //Minor
    if (root > 128){ Fst = root/2 - (down *2); }
    else {Fst = root/2 - down;}
    //Fst = root/2;
    Sec = Fst + 7;
    Thr = Fst + 12;
    For = Fst + 15;
  }
  else if(root >= 180){
    if (root > 192){ Fst = root/3 - (down * 2);}
    else {Fst = root/3 - down;}
    //Fst = root/3;
    Sec = Fst + 4;
    Thr = Fst + 7;
    For = Fst + 10;
  }
}
/*=====================Chord Set END=================================*/
/////////////////////////////////////////////////////////////////////////////////
/*=====================VR Position BEGIN===============================*/


/*=====================VR Position END=================================*/


void SustainON(){
  midiSend(0xB0, 0x40, 127); //Sustain ON
}

void SustainOFF(){
  midiSend(0xB0, 0x40, 0); //Sustain OFF
}

/*
 * //Failed
void Mode4_Trick1(int T,int &count, boolean &cut_note, int &T_old, int &FSR){
  int V = map(FSR, 1023, 20, Zero, 127);
  count ++;
  SustainON();
  T_old = T;
  noteOn(Ch1_ON, T, V);
  cut_note = LOW;
}
*/


void Mode4_Trick(int T,unsigned long &Time,int &count,boolean &cut_note,int &T_old, boolean &Mode4_flag){
  Time = millis();
  count ++;
  T_old = T;
  cut_note = LOW;
  Mode4_flag = HIGH;
}

void Mode4_Note_Set(int T,int &T_Mode4_1, int &T_Mode4_2, int &T_Mode4_3,int &Mode4_count){
  midiSend(0x80, T, 127);
  midiSend(0x80, T_Mode4_1, 127);
  midiSend(0x80, T_Mode4_2, 127);
  midiSend(0x80, T_Mode4_3, 127);
  Mode4_count =0;
 // if ((T % 12  == 0) || (T % 12 == 5) || (T % 12 == 7)){ //求餘數
  T_Mode4_1 = T + 4;
  T_Mode4_2 = T + 7;
  T_Mode4_3 = T_Mode4_1;
  //}

}

void Mode4_Play(unsigned long &Time, int &T, int &T_Mode4_1, int &T_Mode4_2, int &T_Mode4_3,int &Mode4_count, boolean &Mode4_flag){
  if ((millis() - Time >= 0) && (Mode4_count == 0)){
    noteOn(0x90, T, 127);
    Mode4_count ++;
  }
  if ((millis() - Time >= 125) && (Mode4_count == 1)){
    noteOn(0x80, T, 127);
    midiSend(0x90, T_Mode4_1, 100);
    Mode4_count ++;
  }
  if ((millis() - Time >= 250) && (Mode4_count == 2)){
    midiSend(0x80, T_Mode4_1, 127);
    midiSend(0x90, T_Mode4_2, 80);
    Mode4_count ++;
  }
  if ((millis() - Time >= 375) && (Mode4_count == 3)){
    midiSend(0x80, T_Mode4_2, 127);
    midiSend(0x90, T_Mode4_3, 70);
    Mode4_count ++;
  }
  if ((millis() - Time >= 500) && (Mode4_count == 4)){
    midiSend(0x80, T_Mode4_3, 127);
    midiSend(0x90, T_Mode4_2, 70);
    Mode4_count ++;
  }
  if ((millis() - Time >= 625) && (Mode4_count == 5)){
    midiSend(0x80, T_Mode4_2, 127);
    midiSend(0x90, T_Mode4_3, 70);
    Mode4_count ++;
  }
  if ((millis() - Time >= 750) && (Mode4_count == 6)){
    midiSend(0x80, T_Mode4_3, 127);
    midiSend(0x90, T_Mode4_2, 70);
    Mode4_count ++;
  }
  if ((millis() - Time >= 875) && (Mode4_count == 7)){
    midiSend(0x80, T_Mode4_2, 127);
    midiSend(0x90, T_Mode4_3, 70);
    Mode4_count ++;
  }
  if ((millis() - Time >= 1000) && (Mode4_count == 8)){
    midiSend(0x80, T_Mode4_3, 127);
    Mode4_count=0;
    Mode4_flag = LOW;
  }
}


void RPNSend(int cmd, int c1, int c2, int c3, int c4, int c5, int vv){
  Dream.write(cmd);
  Dream.write(c1);
  Dream.write(c2);
  Dream.write(c3);
  Dream.write(c4);
  Dream.write(c5);
  Dream.write(vv);
}

void DefaultSet(){
  PlayCount = 0;
  PlayTime = millis();
}

void Rhythm_Play(int &Rhythm_Nm, int &PlayCount, unsigned long &PlayTime, int Tempo_Speed, int &Drum1, int &Drum2, int &Time){
  if ((Rhythm_Nm > PlayCount) && (millis() >= PlayTime)){
    midiSend(0x99, Drum1, 127);
    midiSend(0x99, Drum2, 127);
    midiSend(0x89, Drum1, 127);
    midiSend(0x89, Drum2, 127);

    PlayTimeSet(PlayTime, Time, Tempo_Speed);
    PlayCount = PlayCount + 1;
  }
  else if ((Rhythm_Nm == PlayCount) && (millis() >= PlayTime)){
    PlayCount = 0;
  }
}

void PlayTimeSet(unsigned long &PlayTime, int Tempo_note, int Tempo_Speed){
  int Note_Base = 60000/Tempo_Speed;
  int Time_Plus;
  if (Tempo_note == 1){
    Time_Plus = Note_Base * 4;
  }
  else if (Tempo_note == 2){
    Time_Plus = Note_Base * 2;
  }
  else if (Tempo_note == 3){
    Time_Plus = Note_Base / 3;
  }
  else if (Tempo_note == 4){
    Time_Plus = Note_Base;
  }
  else if (Tempo_note == 8){
    Time_Plus = Note_Base /2;
  }
  else if (Tempo_note == 16){
    Time_Plus = Note_Base / 4;
  }

  PlayTime = PlayTime + Time_Plus;
}

void BT_Rhythm_Set(int Drum1, int Drum2, int Time, boolean &Rhythm_SW, int Count,int &Tempo_Nm){
  if (Time == 255){
    Tempo_Nm = Count - 2;
    Count = 0;
    Rhythm_SW = LOW;
    //Serial.print("Tempo_Number => "); Serial.println(Tempo_Nm);
  }
  Rhythm1_Drum1[Count -1] = Drum1;
  Rhythm1_Drum2[Count -1] = Drum2;
  Rhythm1_Tempo[Count -1] = Time;
  //Serial.print(DrumSet1[Count -1]); Serial.print(DrumSet2[Count -1]); Serial.println(Tempo[Count - 1]);
  //Serial.print(Drum1); Serial.print(Drum2); Serial.println(Tempo);
}

////測試用
void TestChange(boolean &Main, boolean &Sub1, boolean &Sub2, boolean &Sub3){
  Main = HIGH;
  Sub1 = Sub2 = Sub3 = LOW;
}

